//
// Created by philipp on 15.01.18.
//

#include "../include/Stream.h"

namespace networking
{
namespace stream
{
namespace internal
{

std::string stringFromStreambuf(boost::asio::streambuf & streambuf, std::size_t numBytes)
{
    auto buffers = streambuf.data();
    std::string data{boost::asio::buffers_begin(buffers),
                     boost::asio::buffers_begin(buffers) + numBytes};
    streambuf.consume(numBytes);
    return data;
}

std::uint32_t numDataBytesFromBuffer(boost::asio::streambuf & streambuf)
{
    auto numDataBytesStr = stringFromStreambuf(streambuf, 4);
    return utils::bytesToInt<4, std::uint32_t>((const std::uint8_t *) numDataBytesStr.c_str());
}

std::size_t getNumRemainingBytes(std::size_t numBytesTransferred, std::uint32_t numDataBytes)
{
    using networking::internal::Frame;
    std::size_t numRemainingBytes = 0;
    if (numDataBytes > numBytesTransferred - Frame::HEADER_SIZE)
        numRemainingBytes = numDataBytes - numBytesTransferred - Frame::HEADER_SIZE;
    return numRemainingBytes;
}

}
}
}